/*
    This file is part of myrrdin.

    myrrdin is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as 
    published by the Free Software Foundation, either version 3 of 
    the License, or (at your option) any later version.

    myrrdin is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public 
    License along with myrrdin. If not, see <http://www.gnu.org/licenses/>.
*/

module spriteconsumer;

import dsfml.window.all;
import dsfml.system.all;
import dsfml.graphics.all;

import animatedsprite;
import consumer;
import renderer;

class SpriteConsumer : Consumer {
    private Sprite[] sprites;

    this(Renderer renderer) {
	super(renderer);
    }

    void add_sprite(Sprite sprite) {
	this.sprites ~= sprite;
    }

    void draw() {
	 foreach(Sprite sprite; this.sprites) { 
	    this.renderer.draw(sprite);
	 }
    }
}

